
c-------------------------------------------------------------------------------
c
       subroutine init(lnode,nnode,w,p,volume,myvals)
c
c--Subroutine to Initialize Flow Field
c
      real*8   w(lnode,5),p(lnode),volume(lnode)
      integer myvals(nnode)
c
c--Initialize Constants
c
      gamma     = 1.4D0
      rho0      = 1.0D0
      p0        = 1.0D0
c
      do 10 i=1,nnode
      w(i,1)    = rho0
      w(i,2)    = rho0
      w(i,3)    = rho0
      w(i,4)    = rho0
      w(i,5)    = rho0
      p(i)      = p0
      volume(i) = myvals(i)
  10  continue
c
      return
      end
c
c-------------------------------------------------------------------------------
c
      subroutine readmesh(lnode,ledge,lbface,
     .                  mynodes, myedges, myfaces,
     .                  mynnodes, mynedges, mynfaces,
     .                  nnode,nedge,nbface,nbnode,nde,
     .                  vol,nbf,
     .                  k, filen)
c
c--Read in Relevent (Colored) Data Structures for Flow Solver
c
      implicit none
      common /io/ iread,iwrit,iterm1,iterm2
      character *80 filen
c
      integer lnode,ledge,lbface
      integer  mynodes(lnode), myedges(ledge), myfaces(lbface)
      integer  mynnodes, mynedges, mynfaces
      integer nnode,nedge,nbface, nbnode
      integer nde(ledge,2)
      real*8    vol(lnode)
      integer nbf(lbface,4)

      integer  ndegrp
      integer mynode, numnodes, extra
      integer infile, iwrit
      integer i, ijunk, junk
      real*8 fjunk
      character *80 heading


c
      integer  instart, iestart, ifstart, mynumber, nprocs
      integer  temp, sum_assigned, current_size, current_to
c
      infile  = 9
c
c----------------------------- Formatted Input  --------------------------------
c
      mynumber = mynode()
      nprocs   = numnodes()
      if(mynode() .eq. 0) print *, lnode,ledge,lbface
      if(mynode() .eq. 0) print *, 'reading from', filen
      open(unit=infile,file=filen,form='formatted')
c
      if(mynode() .eq. 0) write(iwrit, 801)
      read (infile,800)
      read (infile,800)
      read (infile,701) nnode,nedge,nbface,ndegrp,nbnode
      read (infile,800)
      read (infile,701) junk,junk,junk,junk

      if(mynode() .eq. 0) print *, nnode,nedge,nbface,ndegrp,nbnode

c
      temp = nnode
      sum_assigned = 0
       mynnodes = nnode/nprocs
       extra = mod(nnode , nprocs)
       if (extra. eq. 0) then
          instart = mynode() * mynnodes
       else
         if(mynode() .lt. extra) then
           instart = mynode() * (mynnodes+1)
           mynnodes = mynnodes + 1
         else
           instart = extra * (mynnodes+1) + (mynumber - extra)*mynnodes
         endif
       endif


c      print *, 'nodes', mynode(), instart, mynnodes
      call gsync()
c
c     calculate begining of local edges in the mesh file
c
      sum_assigned = 0

       mynedges = nedge/nprocs
       extra = mod(nedge , nprocs)
       if (extra. eq. 0) then
          iestart = mynode() * mynedges
       else 
         if(mynode() .lt. extra) then
           iestart = mynode() * (mynedges+1)
           mynedges = mynedges + 1
         else 
           iestart = extra * (mynedges+1) + (mynumber - extra)*mynedges
         endif
       endif
          
c      print *, mynode(), iestart, mynedges
      call gsync()
c
c     calculate begining of local faces in the mesh file
c
       mynfaces = nbface/nprocs
       extra = mod(nbface , nprocs)
       if (extra. eq. 0) then
          ifstart = mynode() * mynfaces
       else
         if(mynode() .lt. extra) then
           ifstart = mynode() * (mynfaces+1)
           mynfaces = mynfaces + 1
         else
           ifstart = extra * (mynfaces+1) + (mynumber - extra)*mynfaces
         endif
       endif

c      print *, 'faces', mynode(), ifstart, mynfaces

      if (mynfaces .gt. lbface) print *, 'Not enuf memory  for face array'
      if (mynedges .gt. ledge) print *, 'Not enuf memory  for edge array'
      if (mynnodes .gt. lnode) print *, 'Not enuf memory  for node array'

      if(mynode() .eq. 0) write(iwrit, 803)
      read (infile,800)heading
c      write (iwrit,800)heading
c      print *, mynode(),iestart, mynedges, nedge-iestart-mynedges
      do 1300 i=1,iestart
      read (infile,701) junk,junk
 1300 continue
      do 1305 i=1,mynedges
      read (infile,701) nde(i,1),nde(i,2)
      myedges(i) = iestart + i 
 1305 continue
      do 1310 i=1,nedge-iestart-mynedges
      read (infile,701) junk,junk
 1310 continue
c     
      do 1405 i=1,mynnodes
      mynodes(i) = instart + i 
 1405 continue
c
      if(mynode() .eq. 0) write(iwrit, 806)
      read (infile,800)
      do 1600 i=1,ifstart
      read (infile,701) junk, junk, junk, junk, junk
 1600 continue
      do 1605 i=1,mynfaces
      read (infile,701) nbf(i,1),nbf(i,2),nbf(i,3),nbf(i,4),ijunk
      myfaces(i) = ifstart + i 
 1605 continue
      do 1610 i=1,nbface-ifstart-mynfaces
      read (infile,701) junk, junk, junk,  junk, junk
 1610 continue

c
 1999 continue
      close(infile)
c
  701 format(8i10)
  702 format(5e19.10)
  703 format(i10,3e16.8,i10)
  704 format(10x,3e16.8)
  800 format(a80)
  801 format('Reading in Parameters ...')
  802 format('Reading in Edge Coloring Indices ...')
  803 format('Reading in Edge List ...')
  804 format('Reading in Vertex Based Control Volumes ...')
  805 format('Reading in Edge Coefficients ...')
  806 format('Reading in Boundary Faces and Associated BCs ...')
  807 format('Reading in Boundary Face Normals ...')
c
1      return
      end
