c-------------------------------------------------------------------------------
       subroutine setup(ledge,lbface,end_pts,nbf, ig_ref, local)
c
c Inspector code
c Loop pre-processing using reglocalize - uniform distribution
c of arrays but irregular data accesses 
c-------------------------------------------------------------------------------
c
c-----------------------------------------
#include "common.F"
c-----------------------------------------
       common/ttable/ itabptr
       common/node/ ntotnodes,nonode,noedge,nobnode,nobface
       common/sched/ lesched,lfsched,lfsched2
       common/offproc/ ne_off_proc,nf_off_proc,nf_off_proc2
c
       integer ledge,lbface
       integer end_pts(ledge,2),nbf(lbface,4)
c
c------ Local Variables
c
       integer ig_ref(nge)
       integer local(nge)
       integer ig(2)
c
c Global references in sweep over  edges
c
       nge1 = 2 * noedge
       do 10 i = 1,noedge
         ig_ref(i)          = end_pts(i,1)
         ig_ref(noedge + i) = end_pts(i,2)
  10   continue
c
c
c Compute schedule for sweep over edges
c
      call reglocalize(1, ntotnodes,lesched,ig_ref,local,nge1,
     .  ne_off_proc,nonode, 5)
c
c end_pts has been used to store references to a globally indexed
c distributed array. We now reuse end_pts to store the index
c to the on-processor buffer location where the local copies
c of the globally indexed distributed array elements are stored.
c
       do 75 i = 1,noedge
         end_pts(i,1) = local(i)
         end_pts(i,2) = local(noedge + i)
  75   continue
c
c Now for the Boundary faces
c
       nbf2 = 2 * nobface
       nbf3 = 3 * nobface
       nbf4 = 4 * nobface
       do 30 i = 1,nobface
         ig_ref(i)           = nbf(i,1)
         ig_ref(nobface + i) = nbf(i,2)
         ig_ref(nbf2 + i)    = nbf(i,3)
         ig_ref(nbf3 + i)    = nbf(i,4)
  30   continue
c
c
c Compute schedule for sweep over faces. regmlocalize computes the
c incremental schedule, i.e. we are taking into account the data
c motion and buffer locations assigned by above call to reglocalize
c
      nsched = 1
      ig(1) = lesched
      call regmlocalize(1,ntotnodes,lfsched,lfsched2,ig_ref,local,nbf4,
     .  nf_off_proc,nf_off_proc2,nonode+ne_off_proc,nsched,ig, 5)
c
c nbf has been used to store references to a globally indexed
c distributed array. We now reuse nbf  to store indices of
c on-processor buffer locations.
c
       do 85 i = 1,nobface
         nbf(i,1) = local(i)
         nbf(i,2) = local(nobface + i)
         nbf(i,3) = local(nbf2 + i)
         nbf(i,4) = local(nbf3 + i)
  85   continue
c
       return
       end

