###################################################################
#                                                                 #
# PARTI : Parallel Automated Runtime Tools from ICASE             #
# Installation makefile                                           #
# Version 1.0          8 July 1990                                #
#                                                                 #
# This make file makes and installs the parti library and include #
# files. The following macros are to be played with by the        #
# poor sod who has to install the system.                         #
#                                                                 #
###################################################################
#
# Second-level Makefile to produce PARTI archives for various
# types of target machines.
#	Bongki Moon, Jan/26/93
#

.SUFFIXES: .lex
LIB   = $(PARTIHOME)/lib
INCL  = $(PARTIHOME)/include
GRUNT = $(PARTIHOME)/src/grunt
SRCS  = utils.c grunt.lex debug.c localize.c mlocalize.c reglocalize.c \
	regmlocalize.c user.c wrap.c wraputils.c hash_schedule.c mem.c \
	regutils.c 
TSRCS = twrap.c
OBJS  = utils.o debug.o localize.o mlocalize.o reglocalize.o \
	regmlocalize.o user.o wrap.o wraputils.o hash_schedule.o mem.o \
	regutils.o
TOBJS = iwrap.o cwrap.o dwrap.o fwrap.o


all: incl $(GRUNT) $(LIB)/$(PARTI) machine_dependent
.PHONY: all machine_dependent clean

incl :
	@if [ -f $(INCL)/port.h ]; then rm -f $(INCL)/port.h; fi
	@ln $(PARTIHOME)/src/$(TARGET)/port.h $(INCL)/port.h
	@if [ -f $(INCL)/parti_comm.h ]; then rm -f $(INCL)/parti_comm.h; fi
	@ln $(PARTIHOME)/src/SYRCOMM/parti_comm.h $(INCL)/parti_comm.h

$(LIB)/$(PARTI) : $(OBJS) $(TOBJS)
	rm -f $(LIB)/$(PARTI)
	$(AR) rcv $(LIB)/$(PARTI) $(OBJS) $(TOBJS)

machine_dependent:
	cd $(TARGET); $(MAKE)
#	ranlib $(LIB)/$(PARTI)
#	@rm $(OBJS) $(TOBJS)

clean:
	@if [ -f $(INCL)/port.h ]; then rm -f $(INCL)/port.h; fi
	@if [ -f $(INCL)/parti_comm.h ]; then rm -f $(INCL)/parti_comm.h; fi
	rm -f $(GRUNT) *.o
	cd $(TARGET); $(MAKE) clean

$(OBJS): %.o: %.c
	$(CC) $(CFLAGS) -I$(INCL) -c $<

# this is for the TYPE-specific compiler gathers and scatters
$(filter i%.o,$(TOBJS)): i%.o: t%.c
	$(GRUNT) int i < $< > $(basename $@).c
	$(CC) $(CFLAGS) -I$(INCL) -c $(basename $@).c
	rm -f $(basename $@).c

$(filter c%.o,$(TOBJS)): c%.o: t%.c
	$(GRUNT) char c < $< > $(basename $@).c
	$(CC) $(CFLAGS) -I$(INCL) -c $(basename $@).c
	rm -f $(basename $@).c

$(filter d%.o,$(TOBJS)): d%.o: t%.c
	$(GRUNT) double d < $< > $(basename $@).c
	$(CC) $(CFLAGS) -I$(INCL) -c $(basename $@).c
	rm -f $(basename $@).c

$(filter f%.o,$(TOBJS)): f%.o: t%.c
	$(GRUNT) float f < $< > $(basename $@).c
	$(CC) $(CFLAGS) -I$(INCL) -c $(basename $@).c
	rm -f $(basename $@).c

.lex:
	lex $(LFLAGS) $<
	cc -O -o $@ lex.yy.c -ll
	rm lex.yy.c

#
# mv .h files and parti.a to appropriate location
#
#install :
#	cp parti.a $(LIB)/parti.a
#	cp *.h $(INCL)
