/*-------------------------------------------------------------------
 * This file is written by Tseng-Hui Lin. If you have any question,
 * please send e-mail to:
 *     thlin@top.cis.syr.edu  or  thlin@nova.npac.syr.edu
 *
 * Last modify : 9/23/1993
 *-------------------------------------------------------------------
 */

#ifndef SYR_PORT_H
#define SYR_PORT_H

/* iPSC does not have memalign(), use malloc() instead */
#define memalign(align, size) malloc(size)

#define SYR_PORT_MAX_M_TYPE (0X000FFFFF) /* 2^20 - 1 = 1,048,575 */

/* General communication calls for all systems */
void SYR_port_init(/*  */);

int SYR_mynode(/*  */);
int SYR_numnode(/*  */);
void SYR_blk_send(/* type, buf, len, dest */);
void SYR_nonblk_send(/* type, buf, len, dest */);
void SYR_sync_send(/* type, buf, len, dest */);
int SYR_async_send(/* type, buf, len, dest */);
void SYR_recv(/* type, buf, len, src */);
void SYR_sync_recv(/* type, buf, len, src */);
int SYR_async_recv(/* type, buf, len, src */);
void SYR_send_recv(/* stype, sbuf, slen, dest, rtype, rbuf, rlen, src */);
void SYR_sync_send_recv(/* stype, sbuf, slen, dest, rtype, rbuf, rlen, src */);
void SYR_swap(/* stype, sbuf, slen, dest, rtype, rbuf, rlen */);
int SYR_recv_len(/* /*  */);
int SYR_recv_sender(/*  */);
int SYR_recv_type(/*  */);
void SYR_async_msg_wait(/* msgid */);
int SYR_async_msg_done(/* msgid */);
void SYR_concat(/* elem, elem_len, whole */);

/* Global synchronous operation */
void SYR_gsync(/*  */);
/* Time routines */
double SYR_clock(/*  */);
/*----------------------------------------------------------------*/
/* Specific communication calls for iPSC */

int SYR_mypid(/*  */);
int SYR_nodedim(/*  */);
#endif SYR_PORT_H
