#include <stdio.h>
#include "parti.h"
#include "parti_more.h"
#define  UNUSED  -1
#define  SIZE     100
#define  TRUE     1
#define  FALSE    0

/* 
   This primitive is created so that we can take off processor elements
   and put them into end of the the local array. For each type of array
   it has to be done once. It will return the schedule and then we can 
   call a gather-localize or scatter-localize to insert the off-processor
   elements in the local array.
*/
typedef struct cell  CELLPTR;

struct cell{
  CELLPTR *nextcell;
  int index;
 };

typedef struct hashcell  HASHPTR;

struct hashcell{
  int node_num;
  int tag;
  HASHPTR *next;
  CELLPTR *slot_num;
};

void
  reglocalize(dist,size,new_sched,global_refs,local_refs,ndata,
                                               n_off_proc,my_size,maxdim)
int dist;
int size;
SCHED  **new_sched; 
int *global_refs;
int *local_refs;
int ndata, maxdim;
int *n_off_proc;
int my_size;
{
  int count,k,jj,i,found;
  int *Fetch_p,*Fetch_l;
  int *proc,*glb1,*lcl1;
  SCHED *temporary_sched;
  HASHPTR  *ptr_hash_st,*check_hash_st,*add_hash_st, *next_h, *temp_h;
  CELLPTR  *cellptr, *next_c, *temp_c;
    
  proc       = (int *)malloc(sizeof(int)*ndata);
  regdereference(dist,size,global_refs,local_refs,proc,ndata);
  ptr_hash_st = (HASHPTR *)malloc(sizeof(struct hashcell)*SIZE);
  for(i=0;i<SIZE;i++){
    ptr_hash_st[i].tag = UNUSED;
    ptr_hash_st[i].next = NULL;
    ptr_hash_st[i].slot_num = NULL;
  }

  for(i=0;i<ndata;i++){
    if(proc[i] != mynode()){
      k = global_refs[i] % SIZE;
      if(ptr_hash_st[k].tag == UNUSED){
        ptr_hash_st[k].tag = 1;
        ptr_hash_st[k].node_num = global_refs[i];
        ptr_hash_st[k].slot_num = (CELLPTR *)malloc(sizeof(struct cell));
        ptr_hash_st[k].slot_num->index = i;
        ptr_hash_st[k].slot_num->nextcell  = NULL;
      }else{
        check_hash_st = &ptr_hash_st[k];
        found = FALSE;
        do{
          if(check_hash_st->node_num == global_refs[i]){
            cellptr = check_hash_st->slot_num;
            while(cellptr->nextcell != NULL) cellptr =cellptr->nextcell;
            cellptr->nextcell = (CELLPTR *)malloc(sizeof(struct cell));
            cellptr = cellptr->nextcell;
            cellptr->index = i;
            cellptr->nextcell  = NULL;
            found = TRUE;
          }else
            add_hash_st = check_hash_st;
          check_hash_st = check_hash_st->next;
        }while((check_hash_st != NULL)&&(!found));
        if(!found){
          add_hash_st->next = (HASHPTR *)malloc(sizeof(struct hashcell));
          add_hash_st = add_hash_st->next;
          add_hash_st->tag = 1;
          add_hash_st->node_num = global_refs[i];
          add_hash_st->next     = NULL;
          add_hash_st->slot_num = (CELLPTR *)malloc(sizeof(struct cell)); 
          add_hash_st->slot_num->index = i; 
          add_hash_st->slot_num->nextcell  = NULL;
        }
      }
    }
  }

  Fetch_p = (int *)malloc(sizeof(int)*ndata);
  Fetch_l = (int *)malloc(sizeof(int)*ndata);
  glb1 = (int *)malloc(sizeof(int)*ndata);
  lcl1 = (int *)malloc(sizeof(int)*ndata);
  count = 0;
  jj = my_size;
  for(i=0;i<ndata;i++){
    if(proc[i] != mynode()&&(proc[i] != -1)){
      Fetch_p[count] = proc[i];
      Fetch_l[count] = local_refs[i];
      glb1[count] = global_refs[i];
      k = global_refs[i] % SIZE;
      check_hash_st = &ptr_hash_st[k];
      found = FALSE;
      while((check_hash_st != NULL)&&(!found))
        if(check_hash_st->node_num == global_refs[i])
          found = TRUE;
        else
          check_hash_st = check_hash_st->next;
        cellptr = check_hash_st->slot_num;
      while(cellptr != NULL){
        local_refs[cellptr->index] = jj;
        proc[cellptr->index] = -1;
        cellptr = cellptr->nextcell;
      }
      lcl1[count++] = jj;
      jj++;
    }
  }
  temporary_sched = schedulen(Fetch_l,Fetch_p,glb1,lcl1,count,maxdim);
  *n_off_proc = count;
  *new_sched = temporary_sched;
  free(proc);
  free(Fetch_p);
  free(Fetch_l);
  free(glb1);
  free(lcl1);

  for(i=0; i< SIZE; i++){
    next_c = ptr_hash_st[i].slot_num;
    while(next_c != NULL) {
      temp_c = next_c->nextcell;
      free(next_c);
      next_c = temp_c;
    }
    next_h = ptr_hash_st[i].next;
    while(next_h != NULL){
      temp_h = next_h->next;
      next_c = next_h->slot_num;
      while(next_c != NULL) {
        temp_c = next_c->nextcell;
        free(next_c);
        next_c = temp_c;
      }
      free(next_h);
      next_h = temp_h;
    }
  }

  free(ptr_hash_st);

}

regdereference(dist,size,global_refs,local,proc,ndata)
int dist;
int size;
int *global_refs;
int *local;
int *proc;
int ndata;
{
  int nprocs, myproc, blocksize1, blocksize2;
  int extra, limit, i;

  nprocs = numnodes();
  myproc = mynode();
  blocksize1 = size/nprocs;
  blocksize2 = blocksize1 + 1;
  extra = size % nprocs;
  limit = (extra * blocksize2) + blocksize1;
  
  switch (dist) {
         case 1: 
             if(!(extra)) {
               for(i=0;i< ndata;i++){
                  proc[i] = global_refs[i] / blocksize1;
                  local[i] = global_refs[i] % blocksize1;
               }
             }else{
               for(i=0;i< ndata;i++){
                  if(global_refs[i] < limit ){
                    proc[i] = global_refs[i] / blocksize2;
                    local[i] = global_refs[i] % blocksize2;
                  }else{
                    proc[i] = (global_refs[i] - limit) / blocksize1 + extra + 1;
                    local[i] = (global_refs[i] - limit) % blocksize1;
                  }
               }
             }
             break;
         case 2:
             for(i=0;i< ndata;i++){
                proc[i] = global_refs[i] % nprocs;
                local[i] = global_refs[i] / nprocs;
             }
             break;
         default :
             fprintf(stderr,"User have to supply own regular derefernce!!\n");
  }
}
