#include <stdio.h>
#include "parti.h"
#include "parti_more.h"
#define  UNUSED  -1
#define  SIZE     100
#define  TRUE     1
#define  FALSE    0

/* 
   This primitive is created so that we can take off processor elements
   and put them into end of the the local array. For each type of array
   it has to be done once. It will return the schedule and then we can 
   call a gather-localize or scatter-localize to insert the off-processor
   elements in the local array.
*/
typedef struct cell  CELLPTR;

struct cell{
      CELLPTR *nextcell;
      int     index;
    };

typedef struct hashcell  HASHPTR;

struct hashcell{
      int     node_num;
      int    	tag;
      int     local;
      HASHPTR *next;
      CELLPTR *slot_num;
    };

regmlocalize(dist,size,lsched1,lsched2,global_refs,local_refs,ndata,
n_off_proc1,n_off_proc2,my_size,n_scheds,scheds,maxdim)
SCHED  **lsched1,**lsched2; 
int *global_refs;
int *local_refs;
int ndata,dist,size;
int *n_off_proc1,*n_off_proc2;
int my_size;
int n_scheds;
SCHED **scheds;
int maxdim;
{
  int count1,count2,k,jj,i,found,ccount;
  int *Fetch_p1,*Fetch_l1,*Fetch_p2,*Fetch_l2;
  int *proc,*glb1,*glb2,*lcl1,*lcl2;
  int jj1;
  SCHED *lsch1,*lsch2;
  HASHPTR  *ptr_hash_st,*temptr,*temmptr, *next_h, *temp_h;
  CELLPTR  *ttemptr, *next_c, *temp_c;
    
  if(n_scheds == 0){
    proc       = (int *)malloc(sizeof(int)*ndata);
    regdereference(dist,size,global_refs,local_refs,proc,ndata);
    ptr_hash_st = (HASHPTR *)malloc(sizeof(struct hashcell)*SIZE);
    for(i=0;i<SIZE;i++){
       ptr_hash_st[i].tag = UNUSED;
       ptr_hash_st[i].next = NULL;
       ptr_hash_st[i].slot_num = NULL;
    }
    for(i=0;i<ndata;i++){
       if(proc[i] != mynode()){
         k = global_refs[i] % SIZE;
         if(ptr_hash_st[k].tag == UNUSED){
           ptr_hash_st[k].tag = 1;
           ptr_hash_st[k].node_num = global_refs[i];
           ptr_hash_st[k].slot_num = (CELLPTR *)malloc(sizeof(struct cell));
           ptr_hash_st[k].slot_num->index = i;
           ptr_hash_st[k].slot_num->nextcell  = NULL;
         }else{
           temptr = &ptr_hash_st[k];
           found = FALSE;
           do{
             if(temptr->node_num == global_refs[i]){
               ttemptr = temptr->slot_num;
               while(ttemptr->nextcell != NULL) ttemptr =ttemptr->nextcell;
               ttemptr->nextcell = (CELLPTR *)malloc(sizeof(struct cell));
               ttemptr = ttemptr->nextcell;
               ttemptr->index = i;
               ttemptr->nextcell  = NULL;
               found = TRUE;
             }else
               temmptr = temptr;
             temptr = temptr->next;
           }while((temptr != NULL)&&(!found));
           if(!found){
             temmptr->next = (HASHPTR *)malloc(sizeof(struct hashcell));
             temmptr = temmptr->next;
             temmptr->tag = 1;
             temmptr->node_num = global_refs[i];
             temmptr->next     = NULL;
             temmptr->slot_num = (CELLPTR *)malloc(sizeof(struct cell)); 
             temmptr->slot_num->index = i; 
             temmptr->slot_num->nextcell  = NULL;
           }
         }
       }
    }

    Fetch_p1 = (int *)malloc(sizeof(int)*ndata);
    Fetch_l1 = (int *)malloc(sizeof(int)*ndata);
    glb1 = (int *)malloc(sizeof(int)*ndata);
    lcl1 = (int *)malloc(sizeof(int)*ndata);
    count1 = 0;
    jj = my_size;
    for(i=0;i<ndata;i++){
       if((proc[i] != mynode())&&(proc[i] != -1)){
         Fetch_p1[count1] = proc[i];
         Fetch_l1[count1] = local_refs[i];
         glb1[count1] = global_refs[i];
         k = global_refs[i] % SIZE;
         temptr = &ptr_hash_st[k];
         found = FALSE;
         while((temptr != NULL)&&(!found)){
              if(temptr->node_num == global_refs[i])
                found = TRUE;
              else
                temptr = temptr->next;
         }
         ttemptr = temptr->slot_num;
         while(ttemptr != NULL){
              local_refs[ttemptr->index] = jj;
              proc[ttemptr->index] = -1;
              ttemptr = ttemptr->nextcell;
         }
         lcl1[count1++] = jj;
         jj++;
       }
    }
    lsch1 = schedulen(Fetch_l1,Fetch_p1,glb1,lcl1,count1,maxdim);

    *n_off_proc1 = count1;
    *lsched1 = lsch1;
    free(proc);
    free(Fetch_p1);
    free(Fetch_l1);
    free(glb1);
    free(lcl1);
    for(i=0; i< SIZE; i++){
       next_h = ptr_hash_st[i].next;
       while(next_h != NULL){
          temp_h = next_h->next;
          next_c = next_h->slot_num;
          while(next_c != NULL) {
            temp_c = next_c->nextcell;
            free(next_c);
            next_c = temp_c;
          }
          free(next_h);
          next_h = temp_h;
       }
    }
  } else {
    proc       = (int *)malloc(sizeof(int)*ndata);
    regdereference(dist,size,global_refs,local_refs,proc,ndata);
    ptr_hash_st = (HASHPTR *)malloc(sizeof(struct hashcell)*SIZE);
    for(i=0;i<SIZE;i++){
	  ptr_hash_st[i].tag = UNUSED;
	  ptr_hash_st[i].next = NULL;
	  ptr_hash_st[i].slot_num = NULL;
	  }

      ccount = 0;
      while(ccount < n_scheds){
          for(i=0;i<scheds[ccount]->ndata;i++){
		     k = scheds[ccount]->global_refs[i] % SIZE;
		     if(ptr_hash_st[k].tag == UNUSED){
		        ptr_hash_st[k].tag = 2;
		        ptr_hash_st[k].node_num = scheds[ccount]->global_refs[i];
                ptr_hash_st[k].local    = scheds[ccount]->local_refs[i];
		     }else{
		        temptr = &ptr_hash_st[k];
		        do{
			      temmptr = temptr;
			      temptr = temptr->next;
			    }while(temptr != NULL);
		        temmptr->next = (HASHPTR *)malloc(sizeof(struct hashcell));
		        temmptr = temmptr->next;
		        temmptr->tag = 2;
                temmptr->node_num = scheds[ccount]->global_refs[i];
		        temmptr->local    = scheds[ccount]->local_refs[i];
		     }
	       }
           ccount++;
      }
	  for(i=0;i<ndata;i++){
       if(proc[i] != mynode()){
	     k = global_refs[i] % SIZE;
	     if(ptr_hash_st[k].tag == UNUSED){
	       ptr_hash_st[k].tag = 4;
		   ptr_hash_st[k].node_num = global_refs[i];
		   ptr_hash_st[k].slot_num = (CELLPTR *)malloc(sizeof(struct cell));
		   ptr_hash_st[k].slot_num->index = i;
		   ptr_hash_st[k].slot_num->nextcell  = NULL;
	     }else{
		   temptr = &ptr_hash_st[k];
           found = FALSE;
		   do{
		     if(temptr->node_num == global_refs[i]){
               if(temptr->tag == 2) temptr->tag = 3;
		       ttemptr = temptr->slot_num;
               if(ttemptr != NULL){
		         while(ttemptr->nextcell != NULL) ttemptr =ttemptr->nextcell;
		         ttemptr->nextcell = (CELLPTR *)malloc(sizeof(struct cell));
		         ttemptr = ttemptr->nextcell;
		         ttemptr->index = i;
		         ttemptr->nextcell  = NULL;
		         found = TRUE;
               } else{
                 temptr->slot_num =(CELLPTR *)malloc(sizeof(struct cell)); 
                 temptr->slot_num->index = i; 
                 temptr->slot_num->nextcell  = NULL;
		         found = TRUE;
               }
		     } else
		       temmptr = temptr;
		     temptr = temptr->next;
		   }while((temptr != NULL)&&(!found));
		   if(!found){
		     temmptr->next = (HASHPTR *)malloc(sizeof(struct hashcell));
		     temmptr = temmptr->next;
		     temmptr->tag = 4;
             temmptr->node_num = global_refs[i];
		     temmptr->next     = NULL;
             temmptr->slot_num = (CELLPTR *)malloc(sizeof(struct cell)); 
             temmptr->slot_num->index = i; 
             temmptr->slot_num->nextcell  = NULL;
		   }
	     }
       }
	  }

      Fetch_p1 = (int *)malloc(sizeof(int)*ndata);
      Fetch_l1 = (int *)malloc(sizeof(int)*ndata);
      glb1     = (int *)malloc(sizeof(int)*ndata);
      lcl1     = (int *)malloc(sizeof(int)*ndata);
      Fetch_p2 = (int *)malloc(sizeof(int)*ndata);
      Fetch_l2 = (int *)malloc(sizeof(int)*ndata);
      glb2     = (int *)malloc(sizeof(int)*ndata);
      lcl2     = (int *)malloc(sizeof(int)*ndata);
      count1 = 0;
      count2 = 0;
      jj = my_size;
      for(i=0;i<ndata;i++){
	    if((proc[i] != mynode())&&(proc[i] != -1)){
          Fetch_p1[count1] = proc[i];
          Fetch_l1[count1] = local_refs[i];
          glb1[count1] = global_refs[i];
	      k = global_refs[i] % SIZE;
	      temptr = &ptr_hash_st[k];
	      found = FALSE;
          while((temptr != NULL)&&(!found)){
		    if(temptr->node_num == global_refs[i])
		      found = TRUE;
		    else
		      temptr = temptr->next;
	      }
          if(temptr->tag == 3){
            jj1 = temptr->local;
	        ttemptr = temptr->slot_num;
	        while(ttemptr != NULL){
		      local_refs[ttemptr->index] = jj1;
              proc[ttemptr->index] = -1;  
		      ttemptr = ttemptr->nextcell;
	        }
          }else{
            jj1 = jj;
            jj++;
            Fetch_p2[count2] = proc[i];
            Fetch_l2[count2] = local_refs[i];
            glb2[count2] = global_refs[i];
            lcl2[count2++] = jj1;
	        ttemptr = temptr->slot_num;
	        while(ttemptr != NULL){
		      local_refs[ttemptr->index] = jj1;
              proc[ttemptr->index] = -1;  
		      ttemptr = ttemptr->nextcell;
	        }
          }
          lcl1[count1++] = jj1;
	    }
      }
      lsch1 = schedulen(Fetch_l1,Fetch_p1,glb1,lcl1,count1,maxdim);
      lsch2 = schedulen(Fetch_l2,Fetch_p2,glb2,lcl2,count2,maxdim);

      *n_off_proc1 = count1;
      *n_off_proc2 = count2;
      *lsched1 = lsch1;
      *lsched2 = lsch2;
      free(Fetch_p1);
      free(Fetch_l1);
      free(glb1);
      free(lcl1);
      free(Fetch_p2);
      free(Fetch_l2);
      free(glb2);
      free(lcl2);
      free(proc);
      for(i=0; i< SIZE; i++){
         next_h = ptr_hash_st[i].next;
         while(next_h != NULL){
            temp_h = next_h->next;
            next_c = next_h->slot_num;
            while(next_c != NULL) {
              temp_c = next_c->nextcell;
              free(next_c);
              next_c = temp_c;
            }
            free(next_h);
            next_h = temp_h;
         }
      }
  }
}
