/********* FORCED TYPED MSG 0 excahnge  with color; ontime alloc**********/

#include <stdio.h>
#include "parti.h"
#include "parti_more.h"

#define FORCED_GATHER_EXECUTOR_MSG	1073742000
#define FORCED_SCATTER_EXECUTOR_MSG	1073752000
#define FORCED_ADD_EXECUTOR_MSG		1073762000
#define FORCED_SUB_EXECUTOR_MSG		1073772000
#define FORCED_MULT_EXECUTOR_MSG	1073782000

#define GATHER_SYNC				100
#define SCATTER_SYNC			200
#define ADD_SYNC				300
#define SUB_SYNC				400
#define MULT_SYNC				500

#define MAXNODES				128

/* This file contains the code for the type specific gather and  */
/* scatter executors. The macro PREFIX is d,i,l, or f.           */
/* The macro TYPE is double, int, long or float to match PREFIX  */
/* Once again, what was once a quick fix is now an established   */
/* policy.                                                       */

void PREFIXexecute_gather(pattern,buf_list,data)
struct com_pattern *pattern;
TYPE **buf_list,*data;
{
  static int call_count;
  int i,j;
  int *l;
  int nprocs,node,pid;
  int *msg_id;
  TYPE *buffer;
  int  myproc;
  int ProcTo;
  int  count;
  char sync_buf[1];
  int TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXexecute_gather");
#endif
  pid      = pattern->pid;
  nprocs   = pattern->nprocs;
  myproc   = pattern->myproc;
  TYPEsize = sizeof(TYPE);
  buffer   = (TYPE *) wbuffer->buffer;
	
  msg_id   = wbuffer->msg_id;

  /* recv data */
  for(count=0,i=0;i<nprocs;i++){
	ProcTo = pattern->gcolor[i];
    if (pattern->fetch_n[ProcTo] > 0 ) {
      msg_id[count++] = irecv(FORCED_GATHER_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
                        buf_list[ProcTo],pattern->fetch_n[ProcTo]*TYPEsize);
	  csend(GATHER_SYNC+call_count+MAXNODES*ProcTo, sync_buf, 0, ProcTo, pid);
    }


  /* send data */
    if(pattern->send_n[ProcTo]>0 ){
      l = pattern->send_list[ProcTo];
      for(j=0;j<pattern->send_n[ProcTo];j++){
        buffer[j] = data[l[j]];
      }
	  crecv(GATHER_SYNC+call_count+MAXNODES*myproc, sync_buf, 0);
      csend(FORCED_GATHER_EXECUTOR_MSG+call_count+MAXNODES*myproc,buffer,
          TYPEsize*pattern->send_n[ProcTo],ProcTo,pid);
    }
    call_count++;
  }

  for (i=0; i<count; i++)
    msgwait(msg_id[i]);

#ifdef DEBUG
  trace_exit();
#endif
}

void
  PREFIXmdexecute_gather(pattern,buf_list,data,base_shift,dialation,repetition)
struct com_pattern *pattern;
TYPE **buf_list,*data;
int base_shift,dialation,repetition;
{
  static int call_count;
  int i,j,ii,ik,jk;
  int *l;
  int nprocs,node,pid;
  int *msg_id;
  TYPE *buffer;
  int  myproc;
  int ProcTo;
  int  count;
  char sync_buf[1];
  int TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXexecute_gather");
#endif
  pid      = pattern->pid;
  nprocs   = pattern->nprocs;
  myproc   = pattern->myproc;
  TYPEsize = sizeof(TYPE);
  buffer   = (TYPE *) wbuffer->buffer;
	
  msg_id   = wbuffer->msg_id;

  /* recv data */
  for(count=0,i=0;i<nprocs;i++){
     ProcTo = pattern->gcolor[i];
     if(pattern->fetch_n[ProcTo] > 0){
       msg_id[count++] = 
               irecv(FORCED_GATHER_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
           buf_list[ProcTo],(repetition*pattern->fetch_n[ProcTo]*TYPEsize));
       csend(GATHER_SYNC+call_count+MAXNODES*ProcTo, sync_buf, 0, 
                                                               ProcTo, pid);
     }


  /* send data */
    if(pattern->send_n[ProcTo]>0 ){
      l = pattern->send_list[ProcTo];
      for(j=0;j<pattern->send_n[ProcTo];j++)
         for(ii=0;ii<repetition;ii++)
            buffer[j*repetition+ii] = data[base_shift*ii+l[j]*dialation];
      crecv(GATHER_SYNC+call_count+MAXNODES*myproc, sync_buf, 0);
      csend(FORCED_GATHER_EXECUTOR_MSG+call_count+MAXNODES*myproc,buffer,
          (TYPEsize*pattern->send_n[ProcTo]*repetition),ProcTo,pid);
    }
    call_count++;
  }

  for (i=0; i<count; i++)
    msgwait(msg_id[i]);

#ifdef DEBUG
  trace_exit();
#endif
}

void PREFIXexecute_scatter(pattern,buf_list,data)
struct com_pattern *pattern;
TYPE **buf_list,*data;
{
  static int call_count=0;
  int i,j;
  int *l;
  int pid,nprocs,node;
  TYPE **buffer;
  int   myproc;
  int   count;
  int    *msg_id;
  char   sync_buf[1];

#ifdef DEBUG
  trace_enter("PREFIXexecute_scatter");
#endif

  nprocs = numnodes();
  myproc = mynode();
  pid    = mypid();

  buffer = (TYPE **) malloc(sizeof(TYPE *)*nprocs);
  msg_id = (int *) malloc(sizeof(int)*nprocs);

  /* recv data */
  for(count=0,i=0; i<nprocs; i++){
    if (pattern->send_n[i] > 0) {
        buffer[count] = (TYPE *) malloc(pattern->send_n[i]*sizeof(TYPE));
        msg_id[count] = irecv(FORCED_SCATTER_EXECUTOR_MSG+call_count+MAXNODES*i,
                        buffer[count], pattern->send_n[i]*sizeof(TYPE));
            csend(SCATTER_SYNC+call_count, sync_buf, 0, i, pid);
        count++;
    }
  }

  for(i=0; i<pattern->n_msgs_to_recv; i++)
          crecv(SCATTER_SYNC+call_count, sync_buf, 0);

  /* send data */
  for(i=0;i<nprocs;i++){
    if(pattern->fetch_n[i]>0){
      csend(FORCED_SCATTER_EXECUTOR_MSG+call_count+MAXNODES*myproc,buf_list[i],
              sizeof(TYPE)*pattern->fetch_n[i],i,pid);
    }
  }

  /* store data */
  for(count=0,i=0; i<nprocs; i++){
    if (pattern->send_n[i] > 0) {
        msgwait(msg_id[count]);
        l = pattern->send_list[i];
        for(j=0;j<pattern->send_n[i];j++){
            data[l[j]] = buffer[count][j];
        }
        count++;
    }
  }
        for (i=0; i<count; i++) free(buffer[i]);

 free(buffer);
  free(msg_id);
  call_count++;
#ifdef DEBUG
  trace_exit();
#endif
}

void
  PREFIXmdexecute_scatter(pattern,buf_list,data,base_shift,dialation,repetition)
struct com_pattern *pattern;
TYPE **buf_list,*data;
int base_shift,dialation,repetition;
{

  static int call_count=0;
  int i,j,ii;
  int *l;
  int pid,nprocs,node;
  TYPE *buffer;
  int   myproc;
  int   count;
  int   ProcTo;
  int    *msg_id;
  static int    *index;
  char   sync_buf[1];
  int	buf_size;
  int	TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXmdexecute_scatter");
#endif
  nprocs = pattern->nprocs;
  myproc = pattern->myproc;
  pid    = pattern->pid;
  TYPEsize = sizeof(TYPE);

	if (call_count == 0) {
    	index = (int *) malloc(sizeof(int)*nprocs);
	}

	buffer = (TYPE *) wbuffer->buffer;
	msg_id = (int *) wbuffer->msg_id;

  /* recv data */
  index[0] = 0;
  for(count=0,i=0; i<nprocs; i++){
	ProcTo = pattern->gcolor[i];
    if(pattern->send_n[ProcTo] > 0) {
      msg_id[count]= irecv(FORCED_SCATTER_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
          &buffer[index[count]], (repetition*pattern->send_n[ProcTo]*TYPEsize));
      csend(SCATTER_SYNC+call_count, sync_buf, 0, ProcTo, pid);
      index[count+1] = index[count] + pattern->send_n[ProcTo]*repetition;
      count++;
    }


  /* send data */
    if(pattern->fetch_n[ProcTo]>0){
      crecv(SCATTER_SYNC+call_count, sync_buf, 0);
      csend(FORCED_SCATTER_EXECUTOR_MSG+call_count+MAXNODES*myproc,
       buf_list[ProcTo],(TYPEsize*pattern->fetch_n[ProcTo]*repetition),ProcTo,pid);
    }
    call_count++;
  }


  for(count=0,i=0; i<nprocs; i++){
     ProcTo = pattern->gcolor[i];
     if(pattern->send_n[ProcTo] > 0) {
       msgwait(msg_id[count]);
       l = pattern->send_list[ProcTo];
       for(j=0;j<pattern->send_n[ProcTo];j++)
          for(ii=0;ii<repetition;ii++)
             data[base_shift*ii+l[j]*dialation] = 
                                  buffer[index[count]+j*repetition+ii];
       count++;
     }
  }

#ifdef DEBUG
  trace_exit();
#endif
}



void PREFIXexecute_add(pattern,buf_list,data)
struct com_pattern *pattern;
TYPE **buf_list,*data;
{

  static int call_count=0;
  int i,j;
  int *l;
  int pid,nprocs,node;
  TYPE *buffer;
  int   myproc;
  int   count;
  int   ProcTo;
  int    *msg_id;
  static int    *index;
  char   sync_buf[1];
  int	buf_size;
  int	TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXexecute_add");
#endif
  nprocs = pattern->nprocs;
  myproc = pattern->myproc;
  pid    = pattern->pid;
  TYPEsize = sizeof(TYPE);

	if (call_count == 0) {
    	index = (int *) malloc(sizeof(int)*nprocs);
	}

	buffer = (TYPE *) wbuffer->buffer;
	msg_id = (int *) wbuffer->msg_id;

  /* recv data */
  index[0] = 0;
  for(count=0,i=0; i<nprocs; i++){
	ProcTo = pattern->gcolor[i];
    if (pattern->send_n[ProcTo] > 0) {
        msg_id[count]= irecv(FORCED_ADD_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
                       &buffer[index[count]], pattern->send_n[ProcTo]*TYPEsize);
	    csend(ADD_SYNC+call_count, sync_buf, 0, ProcTo, pid);
		index[count+1] = index[count] + pattern->send_n[ProcTo];
        count++;
    }


  /* send data */
    if(pattern->fetch_n[ProcTo]>0){
	  crecv(ADD_SYNC+call_count, sync_buf, 0);
      csend(FORCED_ADD_EXECUTOR_MSG+call_count+MAXNODES*myproc,buf_list[ProcTo],
              TYPEsize*pattern->fetch_n[ProcTo],ProcTo,pid);
    }
    call_count++;
  }


  for(count=0,i=0; i<nprocs; i++){
	ProcTo = pattern->gcolor[i];
    if (pattern->send_n[ProcTo] > 0) {
        msgwait(msg_id[count]);
        l = pattern->send_list[ProcTo];
        for(j=0;j<pattern->send_n[ProcTo];j++){
            data[l[j]] += buffer[index[count]+j];
        }
        count++;
    }
  }

#ifdef DEBUG
  trace_exit();
#endif
}

void
  PREFIXmdexecute_add(pattern,buf_list,data,base_shift,dialation,repetition)
struct com_pattern *pattern;
TYPE **buf_list,*data;
int base_shift,dialation,repetition;
{

  static int call_count=0;
  int i,j,ii;
  int *l;
  int pid,nprocs,node;
  TYPE *buffer;
  int   myproc;
  int   count;
  int   ProcTo;
  int    *msg_id;
  static int    *index;
  char   sync_buf[1];
  int	buf_size;
  int	TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXmdexecute_add");
#endif
  nprocs = pattern->nprocs;
  myproc = pattern->myproc;
  pid    = pattern->pid;
  TYPEsize = sizeof(TYPE);

	if (call_count == 0) {
    	index = (int *) malloc(sizeof(int)*nprocs);
	}

	buffer = (TYPE *) wbuffer->buffer;
	msg_id = (int *) wbuffer->msg_id;

  /* recv data */
  index[0] = 0;
  for(count=0,i=0; i<nprocs; i++){
    ProcTo = pattern->gcolor[i];
    if(pattern->send_n[ProcTo] > 0) {
      msg_id[count]= irecv(FORCED_ADD_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
         &buffer[index[count]], (repetition*pattern->send_n[ProcTo]*TYPEsize));
      csend(ADD_SYNC+call_count, sync_buf, 0, ProcTo, pid);
      index[count+1] = index[count] + pattern->send_n[ProcTo]*repetition;
      count++;
    }


  /* send data */
    if(pattern->fetch_n[ProcTo]>0){
      crecv(ADD_SYNC+call_count, sync_buf, 0);
      csend(FORCED_ADD_EXECUTOR_MSG+call_count+MAXNODES*myproc,buf_list[ProcTo],
       (TYPEsize*pattern->fetch_n[ProcTo]*repetition),ProcTo,pid);
    }
    call_count++;
  }


  for(count=0,i=0; i<nprocs; i++){
     ProcTo = pattern->gcolor[i];
     if(pattern->send_n[ProcTo] > 0) {
       msgwait(msg_id[count]);
       l = pattern->send_list[ProcTo];
       for(j=0;j<pattern->send_n[ProcTo];j++)
          for(ii=0;ii<repetition;ii++)
             data[base_shift*ii+l[j]*dialation] += 
                              buffer[index[count]+j*repetition+ii];
       count++;
     }
  }

#ifdef DEBUG
  trace_exit();
#endif
}


void PREFIXexecute_sub(pattern,buf_list,data)
struct com_pattern *pattern;
TYPE **buf_list,*data;
{

  static int call_count=0;
  int i,j;
  int *l;
  int pid,nprocs,node;
  TYPE *buffer;
  int   myproc;
  int   count;
  int   ProcTo;
  int    *msg_id;
  static int    *index;
  char   sync_buf[1];
  int	buf_size;
  int	TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXexecute_sub");
#endif
  nprocs = pattern->nprocs;
  myproc = pattern->myproc;
  pid    = pattern->pid;
  TYPEsize = sizeof(TYPE);

	if (call_count == 0) {
    	index = (int *) malloc(sizeof(int)*nprocs);
	}

	buffer = (TYPE *) wbuffer->buffer;
	msg_id = (int *) wbuffer->msg_id;

  /* recv data */
  index[0] = 0;
  for(count=0,i=0; i<nprocs; i++){
	ProcTo = pattern->gcolor[i];
    if (pattern->send_n[ProcTo] > 0) {
        msg_id[count]= irecv(FORCED_SUB_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
                       &buffer[index[count]], pattern->send_n[ProcTo]*TYPEsize);
	    csend(SUB_SYNC+call_count, sync_buf, 0, ProcTo, pid);
		index[count+1] = index[count] + pattern->send_n[ProcTo];
        count++;
    }


  /* send data */
    if(pattern->fetch_n[ProcTo]>0){
	  crecv(SUB_SYNC+call_count, sync_buf, 0);
      csend(FORCED_SUB_EXECUTOR_MSG+call_count+MAXNODES*myproc,buf_list[ProcTo],
              TYPEsize*pattern->fetch_n[ProcTo],ProcTo,pid);
    }
    call_count++;
  }

  for(count=0,i=0; i<nprocs; i++){
	ProcTo = pattern->gcolor[i];
    if (pattern->send_n[ProcTo] > 0) {
        msgwait(msg_id[count]);
        l = pattern->send_list[ProcTo];
        for(j=0;j<pattern->send_n[ProcTo];j++){
            data[l[j]] -= buffer[index[count]+j];
        }
        count++;
    }
  }
#ifdef DEBUG
  trace_exit();
#endif
}



void
  PREFIXmdexecute_sub(pattern,buf_list,data,base_shift,dialation,repetition)
struct com_pattern *pattern;
TYPE **buf_list,*data;
int base_shift,dialation,repetition;
{

  static int call_count=0;
  int i,j,ii;
  int *l;
  int pid,nprocs,node;
  TYPE *buffer;
  int   myproc;
  int   count;
  int   ProcTo;
  int    *msg_id;
  static int    *index;
  char   sync_buf[1];
  int	buf_size;
  int	TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXmdexecute_sub");
#endif
  nprocs = pattern->nprocs;
  myproc = pattern->myproc;
  pid    = pattern->pid;
  TYPEsize = sizeof(TYPE);

	if (call_count == 0) {
    	index = (int *) malloc(sizeof(int)*nprocs);
	}

	buffer = (TYPE *) wbuffer->buffer;
	msg_id = (int *) wbuffer->msg_id;

  /* recv data */
  index[0] = 0;
  for(count=0,i=0; i<nprocs; i++){
    ProcTo = pattern->gcolor[i];
    if(pattern->send_n[ProcTo] > 0) {
      msg_id[count]= irecv(FORCED_SUB_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
         &buffer[index[count]], (repetition*pattern->send_n[ProcTo]*TYPEsize));
      csend(SUB_SYNC+call_count, sync_buf, 0, ProcTo, pid);
      index[count+1] = index[count] + pattern->send_n[ProcTo]*repetition;
      count++;
    }


  /* send data */
    if(pattern->fetch_n[ProcTo]>0){
      crecv(SUB_SYNC+call_count, sync_buf, 0);
      csend(FORCED_SUB_EXECUTOR_MSG+call_count+MAXNODES*myproc,buf_list[ProcTo],
       (TYPEsize*pattern->fetch_n[ProcTo]*repetition),ProcTo,pid);
    }
    call_count++;
  }


  for(count=0,i=0; i<nprocs; i++){
     ProcTo = pattern->gcolor[i];
     if(pattern->send_n[ProcTo] > 0) {
       msgwait(msg_id[count]);
       l = pattern->send_list[ProcTo];
       for(j=0;j<pattern->send_n[ProcTo];j++)
          for(ii=0;ii<repetition;ii++)
             data[base_shift*ii+l[j]*dialation] -= 
                              buffer[index[count]+j*repetition+ii];
       count++;
     }
  }

#ifdef DEBUG
  trace_exit();
#endif
}


void PREFIXexecute_mult(pattern,buf_list,data)
struct com_pattern *pattern;
TYPE **buf_list,*data;
{

  static int call_count=0;
  int i,j;
  int *l;
  int pid,nprocs,node;
  TYPE *buffer;
  int   myproc;
  int   count;
  int   ProcTo;
  int    *msg_id;
  static int    *index;
  char   sync_buf[1];
  int	buf_size;
  int	TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXexecute_mult");
#endif
  nprocs = pattern->nprocs;
  myproc = pattern->myproc;
  pid    = pattern->pid;
  TYPEsize = sizeof(TYPE);

	if (call_count == 0) {
    	index = (int *) malloc(sizeof(int)*nprocs);
	}

	buffer = (TYPE *) wbuffer->buffer;
	msg_id = (int *) wbuffer->msg_id;

  /* recv data */
  index[0] = 0;
  for(count=0,i=0; i<nprocs; i++){
	ProcTo = pattern->gcolor[i];
    if (pattern->send_n[ProcTo] > 0) {
        msg_id[count]= irecv(FORCED_MULT_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
                       &buffer[index[count]], pattern->send_n[ProcTo]*TYPEsize);
	    csend(MULT_SYNC+call_count, sync_buf, 0, ProcTo, pid);
		index[count+1] = index[count] + pattern->send_n[ProcTo];
        count++;
    }


  /* send data */
    if(pattern->fetch_n[ProcTo]>0){
	  crecv(MULT_SYNC+call_count, sync_buf, 0);
      csend(FORCED_MULT_EXECUTOR_MSG+call_count+MAXNODES*myproc,buf_list[ProcTo],
              TYPEsize*pattern->fetch_n[ProcTo],ProcTo,pid);
    }
    call_count++;
  }


  for(count=0,i=0; i<nprocs; i++){
	ProcTo = pattern->gcolor[i];
    if (pattern->send_n[ProcTo] > 0) {
        msgwait(msg_id[count]);
        l = pattern->send_list[ProcTo];
        for(j=0;j<pattern->send_n[ProcTo];j++){
            data[l[j]] *= buffer[index[count]+j];
        }
        count++;
    }
  }

#ifdef DEBUG
  trace_exit();
#endif
}


void
  PREFIXmdexecute_mult(pattern,buf_list,data,base_shift,dialation,repetition)
struct com_pattern *pattern;
TYPE **buf_list,*data;
int base_shift,dialation,repetition;
{

  static int call_count=0;
  int i,j,ii;
  int *l;
  int pid,nprocs,node;
  TYPE *buffer;
  int   myproc;
  int   count;
  int   ProcTo;
  int    *msg_id;
  static int    *index;
  char   sync_buf[1];
  int	buf_size;
  int	TYPEsize;

#ifdef DEBUG
  trace_enter("PREFIXmdexecute_mult");
#endif
  nprocs = pattern->nprocs;
  myproc = pattern->myproc;
  pid    = pattern->pid;
  TYPEsize = sizeof(TYPE);

	if (call_count == 0) {
    	index = (int *) malloc(sizeof(int)*nprocs);
	}

	buffer = (TYPE *) wbuffer->buffer;
	msg_id = (int *) wbuffer->msg_id;

  /* recv data */
  index[0] = 0;
  for(count=0,i=0; i<nprocs; i++){
    ProcTo = pattern->gcolor[i];
    if(pattern->send_n[ProcTo] > 0) {
      msg_id[count]= irecv(FORCED_MULT_EXECUTOR_MSG+call_count+MAXNODES*ProcTo,
         &buffer[index[count]], (repetition*pattern->send_n[ProcTo]*TYPEsize));
      csend(MULT_SYNC+call_count, sync_buf, 0, ProcTo, pid);
      index[count+1] = index[count] + pattern->send_n[ProcTo]*repetition;
      count++;
    }


  /* send data */
    if(pattern->fetch_n[ProcTo]>0){
      crecv(MULT_SYNC+call_count, sync_buf, 0);
      csend(FORCED_MULT_EXECUTOR_MSG+call_count+MAXNODES*myproc,buf_list[ProcTo],
       (TYPEsize*pattern->fetch_n[ProcTo]*repetition),ProcTo,pid);
    }
    call_count++;
  }


  for(count=0,i=0; i<nprocs; i++){
     ProcTo = pattern->gcolor[i];
     if(pattern->send_n[ProcTo] > 0) {
       msgwait(msg_id[count]);
       l = pattern->send_list[ProcTo];
       for(j=0;j<pattern->send_n[ProcTo];j++)
          for(ii=0;ii<repetition;ii++)
             data[base_shift*ii+l[j]*dialation] *= 
                              buffer[index[count]+j*repetition+ii];
       count++;
     }
  }

#ifdef DEBUG
  trace_exit();
#endif
}
