#include "parti.h"
#include "parti_more.h"

void PREFIXgather(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXgather");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }

  PREFIXexecute_gather(sched->sr,blist,target);

  for(i=0;i<sched->ndata;i++){
    data[sched->perm[i]] = buffer[i];
  }

  free(blist);
  free(buffer);

#ifdef DEBUG
  trace_exit();
#endif
}

void
  PREFIXmultigather(data,target,n_scheds,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_scheds;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,step,ccount,ii;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXgather");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  ccount = 0;
  step = 0;
  while (ccount < n_scheds) {
      buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
      count = 0;
      for(i=0;i<np;i++){
         blist[i] = &buffer[count];
         count += sched[ccount]->sr->fetch_n[i]*repetition;
      }

      PREFIXmdexecute_gather(sched[ccount]->sr,blist,target,
                                          base_shift,dialation,repetition);

      for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
         data[base_shift*ii+step + sched[ccount]->perm[i]*dialation] = 
                                                     buffer[i*repetition+ii];
      step += sched[ccount]->ndata;

      free(buffer);
      ccount++;
  }
  free(blist);

#ifdef DEBUG
  trace_exit();
#endif
}

void 
  PREFIXscatter(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter");
#endif

  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  } 

  for(i=0;i<sched->ndata;i++){ 
    buffer[i] = data[sched->perm[i]]; 
  }  

  PREFIXexecute_scatter(sched->sr,blist,target);

  free(blist);
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}

void
  PREFIXmultiscatter(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ccount,step,ii;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter");
#endif

  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    } 

    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition + ii] = 
                   data[base_shift*ii+step + sched[ccount]->perm[i]*dialation]; 

    PREFIXmdexecute_scatter(sched[ccount]->sr,blist,target,base_shift,
                                               dialation,repetition);
    step += sched[ccount]->ndata;

    free(buffer);
    ccount++;
  }
  free(blist);

#ifdef DEBUG
  trace_exit();
#endif
}

void 
  PREFIXscatter_add(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter_add");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }
    
  for(i=0;i<sched->ndata;i++){
    buffer[i] = data[sched->perm[i]];
  }
    
  PREFIXexecute_add(sched->sr,blist,target);

  free(blist);
  free(buffer);

#ifdef DEBUG
  trace_exit();
#endif
}



void
  PREFIXmultiscatter_add(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ii,step,ccount;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter_add");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition+ii] = 
                   data[base_shift*ii+step+sched[ccount]->perm[i]*dialation];
    
    PREFIXmdexecute_add(sched[ccount]->sr,blist,target,base_shift,
                                                     dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(buffer);
    ccount++;
  }
  free(blist);
#ifdef DEBUG
  trace_exit();
#endif
}


void 
  PREFIXscatter_sub(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXcatter_sub");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }
    
  for(i=0;i<sched->ndata;i++){
    buffer[i] = data[sched->perm[i]];
  }
    
  PREFIXexecute_sub(sched->sr,blist,target);
   
  free(blist);
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void
  PREFIXmultiscatter_sub(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ii,step,ccount;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_sub");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition+ii] = 
                   data[base_shift*ii+step+sched[ccount]->perm[i]*dialation];
    
    PREFIXmdexecute_sub(sched[ccount]->sr,blist,target,base_shift,
                                                     dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(buffer);
    ccount++;
  }
  free(blist);
#ifdef DEBUG
  trace_exit();
#endif
}


void 
  PREFIXscatter_mult(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;
 
#ifdef DEBUG
  trace_enter("PREFIXscatter_mult");
#endif

  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }
    
  for(i=0;i<sched->ndata;i++){
    buffer[i] = data[sched->perm[i]];
  }
    
  PREFIXexecute_mult(sched->sr,blist,target);
   
  free(blist);
  free(buffer);
#ifdef DEBUG 
  trace_exit();
#endif
}


void
  PREFIXmultiscatter_mult(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ii,step,ccount;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_mult");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition+ii] = 
                   data[base_shift*ii+step+sched[ccount]->perm[i]*dialation];
    
    PREFIXmdexecute_mult(sched[ccount]->sr,blist,target,base_shift,
                                                     dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(buffer);
    ccount++;
  }
  free(blist);
#ifdef DEBUG
  trace_exit();
#endif
}



void 
  PREFIXscatter_addnc(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter_addnc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }
    
  for(i=0;i<sched->ndata;i++){
    buffer[i] = 
         data[sched->local_refs[sched->perm[i]]];
  }
    
  PREFIXexecute_add(sched->sr,blist,target);
 
  free(blist);
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void
  PREFIXmultiscatter_addnc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_addnc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+ step +
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_add(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(blist);
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void 
  PREFIXscatternc(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatternc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }
    
  for(i=0;i<sched->ndata;i++){
    buffer[i] = 
         data[sched->local_refs[sched->perm[i]]];
  }
    
  PREFIXexecute_scatter(sched->sr,blist,target);
 
  free(blist);
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void
  PREFIXmultiscatternc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatternc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+ step +
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_scatter(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(blist);
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void 
  PREFIXscatter_subnc(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter_subnc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }
    
  for(i=0;i<sched->ndata;i++){
    buffer[i] = 
         data[sched->local_refs[sched->perm[i]]];
  }
    
  PREFIXexecute_sub(sched->sr,blist,target);
 
  free(blist);
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void
  PREFIXmultiscatter_subnc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_subnc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+ step +
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_sub(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(blist);
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void 
  PREFIXscatter_multnc(data,target,sched)
SCHED *sched;
TYPE *data,*target;
{
  int count,np,i;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter_multnc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  buffer = (TYPE *) malloc(sizeof(TYPE)*sched->ndata);
  count = 0;
  for(i=0;i<np;i++){
    blist[i] = &buffer[count];
    count += sched->sr->fetch_n[i];
  }
    
  for(i=0;i<sched->ndata;i++){
    buffer[i] = 
         data[sched->local_refs[sched->perm[i]]];
  }
    
  PREFIXexecute_mult(sched->sr,blist,target);
 
  free(blist);
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}


void
  PREFIXmultiscatter_multnc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,np,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_multnc");
#endif
  np = numnodes();
  blist = (TYPE **) malloc(sizeof(TYPE *)*np);
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<np;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+ step +
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_mult(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(blist);
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}
