#include <stdio.h>
#include "parti.h"
#include "parti_more.h"

SCHED *schedule(local,proc,ndata,maxdim)
int *local,*proc,ndata,maxdim;
{
  int *bl,nprocs,*pl,**perms,**buckets,*bsize;
  struct com_pattern *sr;
  SCHED *sched;
  int	**PVec;
  int	*GColor;
  int	*SColor;
  int   i;
  int   NPhase;
  int   MyProc;
 
#ifdef DEBUG 
  trace_enter("schedule");
#endif
  nprocs	= numnodes();
  MyProc	= mynode();
  sched		= (SCHED *) malloc(sizeof(SCHED));
  bl		= (int *) malloc(sizeof(int)*ndata);
  pl		= (int *) malloc(sizeof(int)*ndata);
  perms		= (int **) malloc(sizeof(int *)*nprocs);
  buckets	= (int **) malloc(sizeof(int *)*nprocs);
  bsize		= (int *) malloc(sizeof(int)*nprocs);
  sched->global_refs = NULL;
  sched->local_refs = NULL;
  bsort(nprocs,ndata,proc,local,bsize,buckets,perms,bl,pl);
  sr = schedule_gather(bsize,buckets,maxdim);

	/* coloring for gather */

	GColor 	= (int *) malloc(sizeof(int ) *((nprocs+1)/2)*nprocs);
    SColor  = (int *) malloc(sizeof(int ) *((nprocs+1)/2)*nprocs);
	PairColor(GColor, MyProc);

	sr->ncolor	=	NPhase;
	sr->gcolor	= 	GColor;
    sr->scolor 	=   SColor;


  sched->sr 	= sr;
  sched->perm 	= pl;
  sched->ndata 	= ndata;

  free(perms);
#ifdef DEBUG
  trace_exit();
#endif
  return(sched);
}


SCHED *schedulen(local,proc,global,lcl,ndata,maxdim)
int *local,*proc,ndata,*global,*lcl,maxdim;
{
  int *bl,nprocs,*pl,**perms,**buckets,*bsize;
  struct com_pattern *sr;
  SCHED *sched;
  int	**PVec;
  int	*GColor;
  int	*SColor;
  int   i;
  int   NPhase;
  int   MyProc;
 
#ifdef DEBUG 
  trace_enter("schedule");
#endif
  nprocs	= numnodes();
  MyProc	= mynode();
  sched		= (SCHED *) malloc(sizeof(SCHED));
  bl		= (int *) malloc(sizeof(int)*ndata);
  pl		= (int *) malloc(sizeof(int)*ndata);
  perms		= (int **) malloc(sizeof(int *)*nprocs);
  buckets	= (int **) malloc(sizeof(int *)*nprocs);
  bsize		= (int *) malloc(sizeof(int)*nprocs);
  sched->global_refs = (int *) malloc(sizeof(int)*ndata);
  sched->local_refs = (int *) malloc(sizeof(int)*ndata);
  bsort(nprocs,ndata,proc,local,bsize,buckets,perms,bl,pl);
  sr = schedule_gather(bsize,buckets,maxdim);

	/* coloring for gather */

  GColor = (int *) malloc(sizeof(int ) *((nprocs+1)/2)*nprocs);
  SColor = (int *) malloc(sizeof(int ) *((nprocs+1)/2)*nprocs);
  PairColor(GColor, MyProc);


  sr->ncolor = NPhase;
  sr->gcolor = GColor;
  sr->scolor = SColor;


  sched->sr 	= sr;
  sched->perm 	= pl;
  sched->ndata 	= ndata;
  for(i=0;i<ndata;i++){
      sched->global_refs[i] = global[i];
      sched->local_refs[i] = lcl[i];
  }

  free(perms);
#ifdef DEBUG
  trace_exit();
#endif
  return(sched);
}

void dref(local,proc,ndata,offset_table,proc_table)
int *local,*proc,ndata,*offset_table,*proc_table;
{
  SCHED *sr;
  int i,*local_deref,*proc_deref;
   
#ifdef DEBUG
  trace_enter("dref");
#endif
  local_deref = (int *) malloc(sizeof(int)*ndata);
  proc_deref = (int *) malloc(sizeof(int)*ndata);
   
  sr = schedule(local,proc,ndata,1);
  igather(local_deref,offset_table,sr);
  igather(proc_deref,proc_table,sr);

  for(i=0;i<ndata;i++){
    proc[i] = proc_deref[i];
    local[i] = local_deref[i];
  }
  free(local_deref);
  free(proc_deref);
}

SCHED *ischedule(local,proc,ndata,offset_table,proc_table)
int *local,*proc,ndata,*offset_table,*proc_table;
{
  SCHED *sr,*sr1;
  int *local_deref,*proc_deref;
 
#ifdef DEBUG 
  trace_enter("ischedule");
#endif
  local_deref = (int *) malloc(sizeof(int)*ndata);
  proc_deref = (int *) malloc(sizeof(int)*ndata);
 
  sr1 = schedule(local,proc,ndata,1);
  igather(local_deref,offset_table,sr1);
  igather(proc_deref,proc_table,sr1);
  sr = schedule(local_deref,proc_deref,ndata,1);
  return(sr);
#ifdef DEBUG 
  trace_exit();
#endif
}

TTABLE *build_translation_table(type,index_array,ndata)
int type,ndata,*index_array;
{
  int max_index,table_size,i,*offset,*local,*proc;
  SCHED *sr;
  TTABLE *table;
  int nprocs,myproc;
   
  nprocs = numnodes();
  myproc = mynode();
  offset = (int *) malloc(sizeof(int)*ndata);
  local = (int *) malloc(sizeof(int)*ndata);
  proc = (int *) malloc(sizeof(int)*ndata);
  table = (TTABLE *) malloc(sizeof(TTABLE));
   
  /* calculate the size of the table */
  max_index = 0;
  for(i=0;i<ndata;i++){
    max_index = (index_array[i]>max_index) ? index_array[i] : max_index;
  }  
  gihigh(&max_index,1,&i);
  table_size = max_index/nprocs+1;
  table->offset = (int *) malloc(sizeof(int)*table_size);
  table->proc = (int *) malloc(sizeof(int)*table_size);
   
  table->table_size = table_size;
  table->type = type;
  for(i=0;i<ndata;i++){
    offset[i] = i;
    if(type==BLOCKED){
      proc[i] = index_array[i] / table_size;
      local[i] = index_array[i] % table_size;
    }else{
      proc[i] = index_array[i] % nprocs;
      local[i] = index_array[i] / nprocs;
    }
  }              

  sr = schedule(local,proc,ndata,1);
  iscatter(offset,table->offset,sr);

   
  for(i=0;i<ndata;i++){
    offset[i] = myproc;
  }  
  iscatter(offset,table->proc,sr);
  free(offset);
  free(local);
  free(proc);

  return(table);
}

 
void dereference(table,index_array,local,proc,ndata)
int *index_array,ndata;
int *local,*proc;
TTABLE *table;
{
  SCHED *sr;
  int i,nprocs;
   
#ifdef DEBUG
  trace_enter("dreference");
#endif
  nprocs = numnodes();
  for(i=0;i<ndata;i++){
    proc[i] = (table->type == BLOCKED)
                ?       (index_array[i] / table->table_size)
                :       (index_array[i] % nprocs);
    local[i] = (table->type == BLOCKED)
                ?       (index_array[i] % table->table_size)
                :       (index_array[i] / nprocs);
  }              
 
  sr = schedule(local,proc,ndata,1);
  igather(local,table->offset,sr);
  igather(proc,table->proc,sr);

} 
