#include <stdio.h>
#include "parti.h"
#include "parti_more.h"

void 
  bytecopy(a,b,n)
char *a,*b;
long n;
{
  long i;

  for(i=0;i<n;i++){
    a[i] = b[i];
  }
}

/****************************************************************/
/* in:                                                          */
/*   nbuckets                                                   */
/*   ndata                                                      */
/*   key[ndata]                                                 */
/*   data[ndata]                                                */
/* out:                                                         */
/*   bsize[nbuckets]                                            */
/*   *buckets[nbuckets]                                         */
/*   *perms[nbuckets]                                           */
/****************************************************************/
void 
  bsort(nbuckets,ndata,key,data,bsize,buckets,perms,blist,plist)
int nbuckets,ndata,*key,*data,*bsize,**buckets,**perms,*blist,*plist;
{
  int i,count,*bcount,b;

/*  if(mynode() == 15){
    for(i=0;i<ndata;i++) printf("%d : index %d\n",key[i],data[i]);
  } */
  /* find size of each bucket */
  for(i=0;i<nbuckets;i++) bsize[i] = 0;
  for(i=0;i<ndata;i++){
    if(key[i]>=nbuckets){
      fprintf(stderr,
       "[%d]Error in bsort: not enough buckets [i-%d, key-%d, ndata-%d]\n", 
         mynode(), i, key[i], ndata);
      exit();
    }
    bsize[key[i]]++;
  }

  /* allocate memory for buckets */
  count = 0;
  for(i=0;i<nbuckets;i++){
    buckets[i] = &blist[count];
    perms[i] = &plist[count];
    count += bsize[i];
  }

  /* do bucket sort */
  bcount = (int *) malloc(sizeof(int)*nbuckets);
  for(i=0;i<nbuckets;i++) bcount[i] = 0;
  for(i=0;i<ndata;i++){
    b = key[i];
    buckets[b][bcount[b]] = data[i];
    perms[b][bcount[b]] = i;
    bcount[b]++;
  }
  free(bcount);

}

void 
  print_com_pattern(p)
struct com_pattern *p;
{
  int i,j;
   
  for(i=0;i<numnodes();i++){
    if(p->fetch_n[i]!=0){
      printf("node %2d fetchs ",mynode());
      for(j=0;j<p->fetch_n[i];j++){
        printf("%d ",p->fetch_list[i][j]);
      }  
      printf(" from %d\n",i);
    }  
  }   

  for(i=0;i<numnodes();i++){
    if(p->send_n[i]!=0){
      printf("node %2d sends ",mynode());
      for(j=0;j<p->send_n[i];j++){
        printf("%d ",p->send_list[i][j]);
      }  
      printf(" to %d\n",i);
    } 
  }
}   

void 
  check_point(s)
char *s;
{
  gsync();
  if(mynode()==0){
    printf("%s\n",s);
  }  
}

void  
  check_sum(x,n)
double *x;
int n;
{
  int i;
  double sum[3],wrk[3];
 
  sum[0] = 0;
  sum[1] = 0;
  sum[2] = 0;
  for(i=0;i<n;i++){
    sum[0] += x[i];
    sum[1] += x[i]*x[i];
    sum[2] += x[i]*x[i]*x[i];
  }  
 
  gdsum(sum,3,wrk);
 
  if(mynode()==0){
    printf("check sums = %f %f %f\n",sum[0],sum[1],sum[2]);
  }  
}   
  

void
  test_malloc()
{
 char *c,*c1;
 int found=0;
 long i;

 i = 1L;
 c = (char *)malloc(sizeof(char));
 while(found == 0){
	i++;
        c1 = c;
	c = (char *)realloc(c,sizeof(char)*i);
	if(c == NULL){
	fprintf(stdout,"\t the size is(inside parti) %ld : %d\n",i,mynode());
	found = 1;
	}
 }
 free(c1);
}

void
  PairColor(GColor, MyProc)
int *GColor;
int MyProc;
{
	int i;

	for (i=0; i<numnodes(); i++) {
		GColor[i] = MyProc ^ i;
	}
}

void 
  free_table(table)
TTABLE *table;
{
  if(table->offset) free(table->offset);
  if(table->proc) free(table->proc);
  free(table);
}


void
  free_sched(sched)
SCHED *sched;
{
struct com_pattern *pattern;
int node, nprocs;

nprocs  = numnodes();
pattern = sched->sr;

for(node=0; node<nprocs; node++) {
  if (pattern->send_n[node] > 0) {
    if (pattern->send_list[node] != NULL) {
       free(pattern->send_list[node]);
       pattern->send_list[node] = NULL;
    }
  }
}

free(pattern->fetch_list[0]);

free(pattern->send_n);
free(pattern->fetch_n);

free(pattern->send_list);
free(pattern->fetch_list);

free(pattern->gcolor);
free(pattern->scolor);

free(pattern);

if(sched->global_refs) free(sched->global_refs);
if(sched->local_refs) free(sched->local_refs);

free(sched->perm);
free(sched);
}
