#include <stdio.h>
#include "parti.h"
#include "../msrc/graph.h"
#define ARRSIZE 500
#define SCHD    0
#define TABL    1
#define HASH    2

/* structure to keep track type of pointer */
struct cell{
	char *ptr;
	int  ptrtype;
	};

/* structure which is array of the previously defined structures */
typedef struct arr *ARRPTR;
struct arr{
	struct cell   ptrarray[ARRSIZE];
	ARRPTR  next;
	};

int gindex=0;
ARRPTR  gptr,gcptr;


/* misc functions to get and put pointers (sched & ttable) into a global
   array
*/

SCHED *get_sched_ptr(index)
int index;
{
  int hops, found;
  ARRPTR  temptr;


  hops = index / ARRSIZE;
  if(hops == 0)
    if(gptr->ptrarray[index].ptrtype == SCHD){
      return  (SCHED *)gptr->ptrarray[index].ptr;
    }else{ 
      fprintf(stderr,"This is not a schedule pointer\n");
      exit(1);
    }
  else{
    temptr = gptr;
    found = 0;
    while((temptr != NULL)&&(!found)){
         if(hops == 0)
           found = 1;
         else{
           temptr = temptr->next;
           hops--;
          }
    }
    if(!found){
      fprintf(stderr,
               "schedule pointer not found for schedule index %d \n", index);
         exit(1);
    }
    if(temptr->ptrarray[index].ptrtype == SCHD)
      return (SCHED *)temptr->ptrarray[index%ARRSIZE].ptr;
    else{ 
      fprintf(stderr,"This is not a schedule pointer\n");
      exit(1);
    }
  }

}

/* given an index to a ttable return the ttable pointer */
TTABLE *get_table_ptr(index)
int index;
{
  int hops, found;
  ARRPTR  temptr;


  hops = index / ARRSIZE;
  if(hops == 0)
    if(gptr->ptrarray[index].ptrtype == TABL)
      return (TTABLE *)gptr->ptrarray[index].ptr;
    else{ 
      fprintf(stderr,"This is not a translation table pointer\n");
      exit(1);
    }
  else{
    temptr = gptr;
    found = 0;
    while((temptr != NULL)&&(!found)){
         if(hops == 0)
           found = 1;
         else{
           temptr = temptr->next;
           hops--;
         }
    }
    if(!found){
      fprintf(stderr,"ttable pointer not found for table index %d \n", index);
         exit(1);
    }
    if(temptr->ptrarray[index].ptrtype == TABL)
      return (TTABLE *)temptr->ptrarray[index%ARRSIZE].ptr;
    else{ 
      fprintf(stderr,"This is not a ttable pointer\n");
      exit(1);
    }
  }

}

/* given a ptr to a ttable return an index to it */

int register_table(ttable)
TTABLE *ttable;
{
  int index;

  if((index = gindex%ARRSIZE)==0){
    if(gindex == 0){
      gptr = (ARRPTR)malloc(sizeof(struct arr));
      gcptr = gptr;
      gcptr->next = NULL;
    }else{
      gcptr->next = (ARRPTR)malloc(sizeof(struct arr));
      gcptr = gcptr->next;
      gcptr->next = NULL;
    }
  }
  index = gindex%ARRSIZE;
  gcptr->ptrarray[index].ptr     = (char *)ttable;
  gcptr->ptrarray[index].ptrtype = TABL;
  index = gindex++;

  return(index);
}

int register_schedule(schedule)
SCHED *schedule;
{
  int index;

  if ((index = gindex%ARRSIZE)==0){
    if(gindex == 0){
      gptr = (ARRPTR)malloc(sizeof(struct arr));
      gcptr = gptr;
      gcptr->next = NULL;
    }else{
      gcptr->next = (ARRPTR)malloc(sizeof(struct arr));
      gcptr = gcptr->next;
      gcptr->next = NULL;
    }
  }
  index = gindex%ARRSIZE;
  gcptr->ptrarray[index].ptr     = (char *)schedule;
  gcptr->ptrarray[index].ptrtype = SCHD;
  index = gindex++;

  return(index);
}

int register_hashtable(htable)
HTABLE *htable;
{
  int index;

  if((index = gindex%ARRSIZE)==0){
    if(gindex == 0){
      gptr = (ARRPTR)malloc(sizeof(struct arr));
      gcptr = gptr;
      gcptr->next = NULL;
    }else{
      gcptr->next = (ARRPTR)malloc(sizeof(struct arr));
      gcptr = gcptr->next;
      gcptr->next = NULL;
    }
  }
  index = gindex%ARRSIZE;
  gcptr->ptrarray[index].ptr     = (char *)htable;
  gcptr->ptrarray[index].ptrtype = HASH;
  index = gindex++;

  return(index);
}

HTABLE * get_hashtable_ptr(index)
int index;
{
  int hops, found;
  ARRPTR  temptr;

  hops = index / ARRSIZE;
  if(hops == 0)
    if(gptr->ptrarray[index].ptrtype == HASH)
      return  (HTABLE *)gptr->ptrarray[index].ptr;
    else{ 
      fprintf(stderr,"This is not a hash table pointer\n");
      exit(1);
    }
  else{
    temptr = gptr;
    found = 0;
    while((temptr != NULL)&&(!found)){
         if(hops == 0)
           found = 1;
         else{
           temptr = temptr->next;
           hops--;
         }
    }
    if(!found){
      fprintf(stderr,"hashtable pointer not found for hashtable index %d \n", index);
      exit(1);
    }
    if(temptr->ptrarray[index].ptrtype == HASH)
      return (HTABLE *)temptr->ptrarray[index%ARRSIZE].ptr;
    else{ 
      fprintf(stderr,"This is not a hash table pointer\n");
      exit(1);
    }
  }
}
